#########################################
#           SmartSpawns v1.0            #
#             By JoeyT2008              #
#########################################

import es, vecmath, playerlib, gamethread, random, string, os

####CONFIG####
ss_maxspawns = es.ServerVar("ss_maxspawns", 100, "Maximum ammount of spawn points per map.")
ss_minspawns = es.ServerVar("ss_minspawns", 24, "Minimum ammount of spawns reuqired for SmartSpawns to work.")
ss_sampletime = es.ServerVar("ss_sampletime", 10, "Find spawn points every X seconds.")
ss_safedistance = es.ServerVar("ss_safedistance", 250, "Distance away from a player that another player can spawn.")
ss_spawndistance = es.ServerVar("ss_spawndistance", 250, "Minimum distance one spawn point can be from another.")
ss_adddefaultspawns = es.ServerVar("ss_adddefaultspawns", 1, "Add default spawn points to the list.")
##############

es.ServerVar("smartspawns_ver", "1.0").makepublic()
ss_spawns = []
ss_currentmap = ""

def load():
    global ss_currentmap
    ss_currentmap = str(es.ServerVar("eventscripts_currentmap"))
    loadspawns(ss_currentmap)
    if not es.exists("command", "spawn_add"):
        es.regcmd("spawn_add", "smartspawns/spawn_add", "Add a spawn point to the map.")
    if not es.exists("command", "spawn_del"):
        es.regcmd("spawn_del", "smartspawns/spawn_del", "Delete a spawn point from the map.")
    if not es.exists("command", "spawn_list"):
        es.regcmd("spawn_list", "smartspawns/spawn_list", "Delete a spawn point from the map.")
    gamethread.delayedname(ss_sampletime, "findspawns", findspawns)
    if not es.ServerVar("eventscripts_currentmap") == "":
        if len(ss_spawns) == 0:
            if ss_adddefaultspawns == 1:
                defaultspawns()

def unload():
    gamethread.cancelDelayed("findspawns")
    if not ss_currentmap == "":
        savespawns(ss_currentmap)

def es_map_start(event_var):
    if not ss_currentmap == "":
        savespawns(ss_currentmap)
    gamethread.cancelDelayed("findspawns")
    gamethread.delayedname(ss_sampletime, "findspawns", findspawns)
    global ss_currentmap
    ss_currentmap = str(es.ServerVar("eventscripts_currentmap"))
    loadspawns(ss_currentmap)

def spawn_add():
    global ss_spawns
    if es.getargc() == 2:
        ss_spawn = es.getargv(1)
        ss_verify = ss_spawn.split(",")
        if len(ss_verify) == 3:
            if not ss_spawn in ss_spawns:
                ss_spawns.append(ss_spawn)
                es.dbgmsg(0, "Spawnpoint added!")
            else:
                es.dbgmsg(0, "Spawnpoint already exists!")
        else:
            es.dbgmsg(0, "Spawnpoint is invalid!")
    else:
        es.dbgmsg(0, 'Syntax: spawn_add "X,Y,Z"')

def spawn_del():
    global ss_spawns
    if es.getargc() == 2:
        ss_spawn = es.getargv(1)
        ss_verify = ss_spawn.split(",")
        if len(ss_verify) == 3:
            if ss_spawn in ss_spawns:
                ss_spawns.remove(ss_spawn)
                es.dbgmsg(0, "Spawnpoint deleted!")
            else:
                es.dbgmsg(0, "Spawnpoint doesn't exist!")
        elif len(ss_verify) == 1:
            if ss_spawn.lower() == "#all" or ss_spawn.lower() == "#a":
                for ss_spawn in ss_spawns:
                    ss_spawns.remove(ss_spawn)
                es.dbgmsg(0, "All spawnpoints deleted!")
            else:
                ss_x = 0
                try:
                    ss_ammount = int(ss_spawn)
                except:
                    ss_ammount = 0
                if ss_ammount > len(ss_spawns):
                    ss_ammount = len(ss_spawns)
                ss_c1 = len(ss_spawns)
                while (ss_x < ss_ammount):
                    ss_x += 1
                    ss_spawns.remove(random.choice(ss_spawns))
                ss_c = ss_c1 - len(ss_spawns)
                es.dbgmsg(0, "%d spawnpoints deleted!" % ss_c)
        else:
            es.dbgmsg(0, "Spawnpoint is invalid!")
    else:
        es.dbgmsg(0, 'Syntax: spawn_del "X,Y,Z/#all/AMMOUNT"')

def spawn_list():
    es.dbgmsg(0, "%s:" % ss_currentmap)
    ss_num = 0
    for ss_spawn in ss_spawns:
        ss_num += 1
        es.dbgmsg(0, "%d: %s" % (ss_num, ss_spawn))

def loadspawns(ss_map):
    global ss_spawns
    ss_spawns = []
    ss_path = "%s/maps/%s.txt" % (es.getAddonPath("smartspawns"), ss_map)
    if not os.path.exists(ss_path):
        if ss_map != "":
            open(ss_path, "w").close()
    else:
        ss_text = open(ss_path, "r").read()
        for ss_spawn in ss_text.split("\n"):
            if ss_spawn.strip() != "" and not ss_spawn.startswith("//"):
                ss_spawns.append(ss_spawn)

def savespawns(ss_map):
    global ss_spawns
    ss_text = open("%s/maps/%s.txt" % (es.getAddonPath("smartspawns"), ss_map), "w")
    ss_defaultspawns = {}
    ss_list = es.createentitylist("info_terrorist")
    for ss_spawn in ss_spawns:
        ss_text.write(ss_spawn + "\n")
    ss_text.close()

def defaultspawns():
    global ss_spawns
    ss_list = es.createentitylist("info_player_terrorist")
    for ss_spawn in ss_list:
        ss_location = es.getindexprop(ss_spawn, "CBaseEntity.m_vecOrigin")
        if len(ss_spawns) < ss_maxspawns:
            ss_spawns.append(ss_location)
    ss_list = es.createentitylist("info_player_counterterrorist")
    for ss_spawn in ss_list:
        ss_location = es.getindexprop(ss_spawn, "CBaseEntity.m_vecOrigin")
        if len(ss_spawns) < ss_maxspawns:
            ss_spawns.append(ss_location)

def findspawns():
    global ss_spawns
    if len(ss_spawns) < int(ss_maxspawns):
        ss_flags = [66177, 66433]
        for ss_userid in playerlib.getPlayerList("#alive"):
            if es.getplayerprop(int(ss_userid), "CBasePlayer.m_fFlags") in ss_flags and es.getplayerprop(int(ss_userid), "CCSPlayer.baseclass.localdata.m_vecVelocity[2]") == 0.0:
                ss_location = es.getplayerprop(int(ss_userid), "CBaseEntity.m_vecOrigin")
                ss_tooclose = 0
                for ss_spawn in ss_spawns:
                    if vecmath.distance(ss_spawn, ss_location) < ss_spawndistance:
                        ss_tooclose = 1
                if ss_tooclose == 0:
                    ss_spawns.append(ss_location)
    gamethread.delayedname(ss_sampletime, "findspawns", findspawns)

def player_spawn(event_var):
    if len(ss_spawns) >= ss_minspawns:
        ss_players = []
        ss_safespawns = []
        ss_team = "#alive"
        if es.getplayerteam(event_var["userid"]) == 2:
            ss_team = "#ct,#alive"
        if es.getplayerteam(event_var["userid"]) == 3:
            ss_team = "#t,#alive"
        for ss_userid in playerlib.getPlayerList(ss_team):
            ss_players.append(es.getplayerprop(int(ss_userid), "CBaseEntity.m_vecOrigin"))
        for ss_spawn in ss_spawns:
            for ss_id in ss_players:
                if vecmath.distance(ss_id, ss_spawn) > ss_safedistance:
                    ss_safespawns.append(ss_spawn)
        if len(ss_safespawns) > 0:
            ss_spawn = random.choice(ss_safespawns).split(",")
        else:
            ss_spawn = random.choice(ss_spawns).split(",")
        es.setpos(event_var["userid"], ss_spawn[0], ss_spawn[1], ss_spawn[2])

def round_start(event_var):
    if len(ss_spawns) == 0:
        if ss_adddefaultspawns == 1:
            defaultspawns()
    es.msg("#multi", "#green[SmartSpawns] #defaultcreated by #lightgreenJoeyT2008#default.")

def player_say(event_var):
    if event_var["text"].lower() == "!spawns":
        es.tell(event_var["userid"], "#multi", "#green[SmartSpawns] #defaultThere are #lightgreen%d#default spawn points in this map!" % len(ss_spawns))